//■■SingleFileFilter.java

import java.io.File;
import javax.swing.filechooser.FileFilter;

//■■単一拡張子によるファイルフィルター
public class SingleFileFilter extends FileFilter
{
    private String extention;   //拡張子
    private String description; //説明文
    public SingleFileFilter(String ext)
    {
        extention = ext.toLowerCase(); //小文字に統一
        description = "*." + extention;
    }
    public boolean accept(File f)
    {
        if(f.isDirectory())
            return true;
        return f.getName().toLowerCase().endsWith(
            "." + extention); //ファイル名の末尾判定合否を通知
    }
    public String getDescription()
    {
        return description; //説明文を通知
    }
}
