//■■Util.java

import java.awt.*;
import java.awt.event.*;
import java.awt.im.InputSubset;
import javax.swing.*;
import javax.swing.border.*;
import java.io.*;
import java.util.*;
import java.text.*;

public class Util
{
    static final Font fontM = new Font("MonoSpaced",Font.PLAIN,13);

    //■テキストファイル閲覧サブウィンドウ
    public static void textBrowse(SystemMessage sm, File file)
    {
        String line = null;
        JDialog subWindow = null;
        try
        {
            BufferedReader reader = new BufferedReader(
                new FileReader(file)); //エラーになればsubWindowは生成しない

            subWindow = new JDialog((Frame)sm, file.getName(), true);
            Container pane = subWindow.getContentPane();
            //クローズボタンでサブウィンドウを破棄し、プロセスは継続させる
            //subWindow.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
            JTextArea tArea = new JTextArea(25,80); //行数と１行の文字数
            pane.add(
                new JScrollPane(
                    tArea,
                    JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                    JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS));
            tArea.setFont(fontM);
            tArea.setBorder(new EmptyBorder(20,20,20,20));
            try
            {
                for (;;)
                {
                    line = reader.readLine();
                    if(line == null)
                        break;
                    tArea.append(line + "\n");
                }
                tArea.select(0, 0); //先頭位置を表示
                tArea.setEditable(false); //編集禁止
            }
            catch(IOException e)
            {
                sm.message("読取エラー>>\n"+e);
            }
            finally
            {
                reader.close();
                subWindow.pack();
                subWindow.setVisible(true);
            }
        }
        catch(FileNotFoundException e)
        {
            sm.message("オープンエラー>>\n"+e);
        }
        catch(IOException e)
        {
            sm.message("クローズエラー>>\n"+e);
        }
    }
    //■テキストファイル閲覧サブウィンドウ（クリップ・ボード機能付き）
    public static void textBrowseCCP(SystemMessage sm, File file)
    {
        String line = null;
        JDialog subWindow = null;
        try
        {
            BufferedReader reader = new BufferedReader(
                new FileReader(file)); //エラーになればsubWindowは生成しない

            subWindow = new JDialog((Frame)sm, file.getName(), true);
            Container pane = subWindow.getContentPane();
            JPanel panel = new JPanel();
            panel.setLayout(new FlowLayout(FlowLayout.LEFT));
            
            Box vBox = Box.createVerticalBox();
            pane.add(vBox);
            JTextArea tArea = new JTextArea(25,80); //行数と１行の文字数
            tArea.setFont(fontM);
            tArea.setBorder(new EmptyBorder(20,20,20,20));

            JButton cutButton = new JButton("削除");
            cutButton.addActionListener(
            	new ActionListener()
            	{ public void actionPerformed(ActionEvent event)
              	{ tArea.cut(); } } 
            );
            JButton copyButton = new JButton("複写");
            copyButton.addActionListener(
            	new ActionListener()
            	{ public void actionPerformed(ActionEvent event)
              	{ tArea.copy(); } } 
            );
            JButton pasteButton = new JButton("挿入");
            pasteButton.addActionListener(
            	new ActionListener()
            	{ public void actionPerformed(ActionEvent event)
              	{ tArea.paste(); } } 
            );
            panel.add(cutButton);
            panel.add(copyButton);
            panel.add(pasteButton);
            vBox.add(panel);
            vBox.add(
                new JScrollPane(
                    tArea,
                    JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                    JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS));

            try
            {
                for (;;)
                {
                    line = reader.readLine();
                    if(line == null)
                        break;
                    tArea.append(line + "\n");
                }
                tArea.select(0, 0); //先頭位置を表示
                tArea.setEditable(true); //編集可
            }
            catch(IOException e)
            {
                sm.message("読取エラー>>\n"+e);
            }
            finally
            {
                reader.close();
                subWindow.pack();
                subWindow.setVisible(true);
            }
        }
        catch(FileNotFoundException e)
        {
            sm.message("オープンエラー>>\n"+e);
        }
        catch(IOException e)
        {
            sm.message("クローズエラー>>\n"+e);
        }
    }

    //■改行コードを含む文字列を改行位置で分解し、Stringの配列に変換して返却
    public static String[] splitReturn(String str)
    {
        if(str.charAt(str.length()-1)!='\n')
            str = str + "\n";
        int lines=0;
        for(int i=0; i<str.length(); i++)
        {
            if(str.charAt(i)=='\n')
                lines++;
        }
        String [] stringArray = new String[lines];
        int c1=0;
        int c2=0;
        int lineNum=0;
        int i=0;
        for(; i<str.length(); i++)
        {
            if(str.charAt(i)=='\n')
            {
                c2=i;
                stringArray[lineNum] = str.substring(c1,c2);
                lineNum++;
                
                c1=c2+1;
            }
        }
        return stringArray;
    }

    //■CSV形式の文字列を想定し、区切り文字（デリミタ）の数を数えて、その数を返却
    public static int countDelimiter(String str, char ch)
    {
      int cnt=0;
      for(int i=0; i<str.length(); i++)
      {
        if(str.charAt(i)==ch)
          cnt++;
      }
      return cnt;
    }

    //■CSV形式の文字列を区切り文字の位置で分解し、Stringの配列に変換して返却
    public static String[] csv2Array(String csv, int cols)
    {
        return csv2Array(csv, cols, ',');
    }
    public static String[] csv2Array(String csv, int cols, char delimiter)
    {
        char [] cArr = {delimiter};
        String delimiterStr = new String(cArr);
        StringTokenizer st = new StringTokenizer(csv, delimiterStr, true);
        int cols2 = 0;
        for(int i=0; i<csv.length(); i++)
        {
            if(csv.charAt(i) == delimiter)
                cols2++;
        }
        cols2++; //カラム数
        if(cols > 0) //カラム数チェック必要
        {
            if(cols != cols2) //カラム数異常
                return null;
        }
        else if(cols == 0) //カラム数チェック不用
            cols = cols2;
        else if(cols < 0) //program error
            ; //次の文で例外発生
        String [] stringArray = new String[cols];
        for(int colCount=0; colCount<cols; colCount++)
        {
            String str;
            if(st.hasMoreTokens()) //トークンがあれば
                str = (st.nextToken()).trim();//区切り文字かデータが得られ
            else                   //トークンがなければ
                str = "";          //最終カラムで、空のカラム

            if(str.equals(delimiterStr))    //トークンが区切り文字か
                str = "";          //最終カラム以外で、空のカラム
            else                   //トークンがデータなら
            {
                if(st.hasMoreTokens()) //最終カラムでないことを確認し
                    st.nextToken();    //次のコンマ除去
            }
            stringArray[colCount] = str; //データか空文字列を格納
        }
        return stringArray;
    }

    //■文字列の先頭と末尾を囲む特定文字を除去。
    //主に引用符や括弧で囲まれた文字列に適用。
    //前後を除去文字に囲まれていなければ、そのまま返却。
    public static String trimAffix(String str, char prefix, char suffix)
    {
        if(str.length()>=2 && str.charAt(0)==prefix && str.charAt(str.length()-1)==suffix)
            return str.substring(1, str.length()-1);
        else
            return str;
    }

    //■JTextField の日本語ＩＭモード切替
    public static void kanjiIn(final JTextField tf, boolean b)
    {
        if(b)
        {
            tf.addFocusListener(new FocusAdapter()
            {
                public void focusGained(FocusEvent event)
                {
                    tf.getInputContext().setCharacterSubsets(
                        new Character.Subset[] {InputSubset.KANJI});
                }
            });
        }
        else
        {
            tf.addFocusListener(new FocusAdapter()
            {
                public void focusGained(FocusEvent event)
                {
                    tf.getInputContext().setCharacterSubsets(null);
                }
            });
        }
    }

    //■数値文字列の整形
    //返却値 String : 整形後の文字列
    //引数 String decimal : 十進実数文字列
    //引数 int fractionDigit : 整形後の小数点桁数
    //引数 boolean comma ：コンマが必要か
    //機能 : 指定の小数点桁数で揃え、必要ならコンマを付加
    public static String decimalStringFormat(String decimal, int fractionDigit, boolean comma)
        throws NumberFormatException
    {
        String s0 = "";
        String s1 = "";
        NumberFormat nf = NumberFormat.getInstance(Locale.JAPANESE);

        if(decimal==null)                  //nullなら
            throw new NumberFormatException("文字列がnull");
        else if(decimal.trim().equals("")) //空文字列なら
            return "";
        else                               //有効文字列なら
        {
            if(decimal.indexOf(".")==-1) //整数表記されていたらコンマ要求とみなし
            {
                s0 = nf.format(Long.parseLong(decimal)); //整数にコンマ付加
                s1 = "";
            }
            else if(comma==true) //実数表記でコンマ要求されていたら
            {
                s0 = decimal.substring(0,decimal.indexOf(".")); //整数部
                if(!s0.equals("-0")) //実数が１未満の場合には符号温存
                    s0 = nf.format(Long.parseLong(s0));   //整数部コンマ付加
                s1 = decimal.substring(decimal.indexOf(".")+1); //小数部
            }
            else //実数表記でコンマ要求なし
            {
                s0 = decimal.substring(0,decimal.indexOf(".")); //整数部
                s1 = decimal.substring(decimal.indexOf(".")+1); //小数部
            }
            if(fractionDigit == 0)     //整数要求
                return s0;
            else if(fractionDigit > 0) //実数要求
            {
                for(int i=0; s1.length()>i; i++)                //小数部チェック
                    if(!Character.isDigit(s1.charAt(i)))
                        throw new NumberFormatException();
                if(fractionDigit < s1.length())
                    s1 = s1.substring(0,fractionDigit);         //末尾切捨
                else if(fractionDigit > s1.length())
                    while(fractionDigit>s1.length())
                        s1 += "0";                              //不足の0を付加
                return (s0 + "." + s1);
            }
            else //小数のマイナス桁は認めない
                throw new NumberFormatException("小数桁がマイナス値");
        }
    }
    public static String decimalStringFormat(String decimal, int fractionDigit)
        throws NumberFormatException
    {
        return decimalStringFormat(decimal, fractionDigit, true);
    }

    //■数値データの変換と照合
    public static int checkInt(String str, int min, int max) throws Exception
    {
        try
        {
            int value = Integer.parseInt(str);
            if(value<min || value>max)
                throw new Exception("数値異常");
            return value;
        }
        catch(NumberFormatException e)
        {
            throw new Exception("数値表記間違");
        }
    }
    public static long checkLong(String str, long min, long max) throws Exception
    {
        try
        {
            long value = Long.parseLong(str);
            if(value<min || value>max)
                throw new Exception("数値異常");
            return value;
        }
        catch(NumberFormatException e)
        {
            throw new Exception("数値表記間違");
        }
    }
    public static double checkDouble(String str, double min, double max) throws Exception
    {
        try
        {
            double value = Double.parseDouble(str);
            if(value<min || value>max)
                throw new Exception("数値異常");
            return value;
        }
        catch(NumberFormatException e)
        {
            throw new Exception("数値表記間違");
        }
    }
    //■CSV簡易データベース
    public static String[] searchCSV(String fileName, String keyWord, int cols, int col)
    //colsは１起算
    //col は０起算
    {
        File file = new File(fileName);
        String ret = null;
        //データ形式は、CSV
        String[] strArr = new TextIO().loadStrArr(file);
        if(strArr==null || strArr.length==0)
        {
            System.err.println("データ・ファイルに問題。"+file.getName());
            return null;
        }
        String[] datArr = null;
        for(int i=0; i<strArr.length; i++)
        {
            datArr = csv2Array(strArr[i], cols);
            if(datArr==null)
                System.err.println("データベースの一部が損壊。"+file.getName());
            else if(datArr[col].equals(keyWord))
                return datArr;
        }
        System.err.println("データベースに該当項目なし。"+file.getName());
        return null;
    }
}
